{  (c) jean-Yves Quinec j.y.q@wanadoo.fr

 Unit de dmonstration de rotation et de redimensionnement de bitmap, avec
 utilisation d'une mthode originale et performante d'interpolation de pixels.
 Cette mthode est utilise dans les procdures Bmprotation et Smoothresize.

 Le programme montre aussi comment grer la souris pour:
 - Redimensionner un rectangle en utilisant des poignes.
 - Choisir facilement l'angle de rotation.
 - Slectionner une portion rectangulaire de l'image.

 Principe de l'interpolation
 ============================
 Le Bitmap lu qui subit la rotation est Bmp1. C'est aussi le bitmap rsultat
 de la rotation. un bitmap intermdiaore Bmp2 est utilis.

 Pour effectuer une rotation au 1/10 de degr, cliquer dans l'image en
 maintenantle bouton de la souris enfonc. Une ligne passant par le centre
 de l'image montre l'inclinaison choisie en dplaant la souris.
 L'angle coespondant est affich.

 La rotation produit un Bitmap agrandi en fonction de l'angle de rotation.
 Pour simplifier le calcul des recentrages, on commence par copier le bitmap
 Bmp1 centr dans le bitmap de manoeuvre Bmp2. Bmp2 est  la nouvelle taille,
 et il est rempli avec une couleur de fond. Bmp1 (rsultat) est aussi agrandi.

 Pour tre certain de traiter l'image sans trous, c'est le bitmap de
 destination Bmp1 qui sert de base au traitement.
 On applique donc la rotation en sens inverse, et on calcule le pixel
 origine de Bmp2 qui donnne le pixel courant de Bmp1 aprs rotation.

 Pour viter les effets d'escalier, on tient compte des pixels entourant
 le pixel origine de la manire suivante, qui permet un calcul rapide avec
 des entiers :
 Les coordonnes sont multiplies par 3 avant d'appliquer la rotation
 inverse. On calcule la rotation. On divise ensuite par 3 pour avoir le
 pixel origine de Bmp2  utiliser. Les restes x et y de la division donnent
 un emplacement plus fin  l'intrieur de ce pixel, qui est virtuellement
 divis en 9 cases, ce qui va nous servir  amliorer le rsultat.

    pixel   |  pixel    | pixel
      NO    |  Nord     |  NE
       -----+---+---+---+-----
            | 0 | 1 | 2 |
     pixel  +---+---+---+  pixel
     Ouest  | 3 | 4 | 5 |   Est
            +---+---+---+
            | 6 | 7 | 8 |
       -----+---+---+---+-----
   pixel SO | pixel Sud |  pixel SE

  pour chacune des 9 cases on utilise une matrice de convolution 3x3 qui
  affecte un poids  chacun des 8 pixels entourant le pixel trait.
  Par exemple  si le reste de la division donne dx = 2 et dy = 0  on
  se touve dans la case 2, c'est  dire le coin nord est.
  dans ce cas  seuls les pixels Nord, NE, Est et le pixel origine auront de
  l'influence sur le rsultat. La matrice correspondante sera

  +---+---+---+
  | 0 | 7 | 2 |   et le calcul des couleurs, par exemple le rouge  sera
  +---+---+---+
  | 0 | 16| 7 | R2[y2,x2]= (R3[y3-1,x3-1]*0+ R3[y3-1,x3]*7+ R3[y3-1,x3+1]*2
  +---+---+---+            +R3[y3  ,x3-1]*0+ R3[y3 ,x3]*16+ R3[y3  ,x3+1]*7
  | 0 | 0 | 0 |            +R3[y3+1,x3-1]*0+ R3[y3+1,x3]*0+ R3[y3+1,x3+1]*0
  +---+---+---+            ) / 32

  Noter que la somme des coefficients vaut 32 d'o la division par 32
  pour que le calcul de la moyenne respecte la luminosit.
  Pour la case centrale n 4 on pourrait ne rien faire et prendre le
  pixel correcpondant de Bmp2. Mais comme l'interpolation gnre un certain
  adoucissement (lissage) on en profite pour effectuer un durcissement
  avec la matrice ci dessous.

  +---+---+---+
  |-1 | 1 |-1 |
  +---+---+---+
  | 1 | 32| 1 |
  +---+---+---+
  |-1 | 1 |-1 |
  +---+---+---+

 Il faut 9 matrices de taille 3x3 pour effectuer l'interpolation des pixels
 La position 3x3 s'obtient en fonction du reste de la division par 3
 du calcul,  partir des coordonnes bitmap origine multiplies par 3
-- }

unit RotUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs, JPEG, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Image1: TImage;
    PaintBox1: TPaintBox;
    Button3: TButton;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ComboBox1: TComboBox;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button4: TButton;
    CheckOptim: TCheckBox;
    SpeedButton3: TSpeedButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure initbitmap;
    procedure afficheangle(aaa : single);
    procedure axesrotation(ax, ay : integer; zangle : single);
    Procedure Homothetie(x, y : integer);
    procedure poignees;
    Function  clicpoignee(ax, ay : integer): integer;
    Procedure Movepoignee(dx, dy, numero : integer);
    procedure afficheDimensions;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


const
   MM : array[0..8, 0..2, 0..2] of integer =   // diviseur = 32
((( 2, 7, 0),
  ( 7,16, 0),
  ( 0, 0, 0)),     // NO

 (( 1, 8, 1),
  ( 3,16, 3),
  ( 0, 0, 0)),     // Nord

 (( 0, 7, 2),
  ( 0,16, 7),
  ( 0, 0, 0)),     // NE

 (( 1, 3, 0),
  ( 8,16, 0),
  ( 1, 3, 0)),     // Ouest

 ((-1, 1, -1),
  ( 1,32, 1),
  (-1, 1, -1)), // centre -> durcir

 (( 0, 3, 1),
  ( 0,16, 8),
  ( 0, 3, 1)),     // Est

 (( 0, 0, 0),
  ( 7,16, 0),
  ( 2, 7, 0)),     // SO

 (( 0, 0, 0),
  ( 3,16, 3),
  ( 1, 8, 1)),     // Sud

 (( 0, 0, 0),
  ( 0,16, 7),
  ( 0, 7, 2)));    // SE


type
  TRGBArray = ARRAY[0..0] OF TRGBTriple;   // lment de bitmap (API windows)
  pRGBArray = ^TRGBArray;     // type pointeur vers tableau 3 octets 24 bits

var
  AAction : integer;   // 0 rien, 1 rotation, 2 redimensionnement, 3 slection
                      // permet de savoir s'il faut effacer les poignes
  bmp1 : Tbitmap;     // bitmap lu et retravaill
  angle : single;     // angle de rotation
  centrex, centrey : integer;   // centre de l'image
  // les manipulations souris utilisent des variables globales pour
  // pouvoir effacer les repres lors de l'vnement onmousemove
  drawing : boolean;            // manipuation souris en cours
  startx, starty : integer;     // pour lignes xor de la rotation
  RR : Trect;                   // pour rectangle redimensionnement
  numpoigne : integer;          // n de poigne clique pour redimensionnement
  selrect : Trect;              // pour rectangle slection

//------------- quelques  outils de calcul -------------------------------
// Rotation de centre cx, cy du point (wx, wy)
Function rotpt(cx, cy, wx, wy: integer; wangle : single) : tpoint;
var
  cx1, cy1, cx2, cy2 : single;
begin
  cx1 := cx;    // conversions en single
  cy1 := cy;
  cx2 := wx;
  cy2 := wy;
  cx2 := cx2 - cx1;  // distances
  cy2 := cy2 - cy1;
  result.x := cx + round(cx2*cos(wangle) + cy2*sin(wangle));
  result.y := cy + round(cx2*sin(wangle) - cy2*cos(wangle));
end;

function maxi(a,b : integer): integer;
begin
  if a > b then result := a else result := b;
end;

// donne l'inclinaison d'un segment orient en radians
Function Inclin(cx, cy, wx, wy : integer) : single;
var
  symetrie : boolean;
  dsx : single;
  dsy : single;
  sangle : single;  // angle en radians
begin
  wx := wx - cx;                 { distances par rapport au centre }
  wy := wy - cy;
  if wx < 0 then symetrie := true else symetrie := false;
  dsx := abs(wx * 1.0);
  dsy := -wy * 1.0;
  IF dsx < 0.001 then  { protection division par zro calcul arc tangente }
  begin
    if dsy < 0 then sangle := pi+pi/2 else sangle := pi/2;
  end
  else
  begin
    sangle := arctan(dsy / dsx);
    IF symetrie then sangle := pi - sangle;
  end;
  result := sangle;
end;

// distance de deux points
Function Distance(x1, y1, x2, y2 : integer): integer;
// Calcul de l'hypothnuse a := sqrt(dx*dx+dy*dy)
// en utilisant la formule de Newton pour le calcul de la racine carre
// 12 itrations suffisent :  sqrt(a) -->  Xo = (1+a)/2  et  Xn+1 = (xn+a/xn)/2
// C'est 3 fois plus rapide que  j := trunc(sqrt(sqr(dx)+sqr(dy)))
var
  i : Integer;
  a, r0, r1 : Integer;
begin
  r0 := x2-x1;
  r1 := y2-y1;
  a := r0*r0 + r1*r1;
  r1 := (1+a) DIV 2;
  FOR i := 1 TO 12 DO
  begin
    r0 := r1;
    IF r0 > 0 then r1 := (r0+(a div r0)) div 2;
  end;
  Result:= r1;
end;
//------------- fin outils de calcul -------------------------------

//---------- Section traitements principaux de la fiche -----------
procedure TForm1.FormCreate(Sender: TObject);
begin
  AAction := 0;
  bmp1 := Tbitmap.create;
  bmp1.pixelformat := pf24bit;
  bmp1.width := 8;
  bmp1.height := 8;
  openpicturedialog1.initialdir := getcurrentdir;
  angle := 0.0;
  afficheangle(angle);
  drawing := false;
  centrex := paintbox1.width div 2;
  centrey := paintbox1.height div 2;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  bmp1.free;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  centrex := paintbox1.width div 2;
  centrey := paintbox1.height div 2;
  RR := bounds((paintbox1.width-bmp1.width) div 2,
        (paintbox1.height-bmp1.height) div 2, bmp1.width, bmp1.height);
end;

procedure TForm1.Button2Click(Sender: TObject);   // lecture
begin
 // lit une image Bmp ou JpG
  speedbutton1.down := false;
  speedbutton2.down := false;
  speedbutton3.down := false;
  AAction := 0;
  if openpicturedialog1.execute then
  begin
   try
     Image1.Picture.LoadFromFile(openpicturedialog1.Filename);
   except
     on EInvalidGraphic do
     begin
       Image1.Picture.Graphic := nil;
       showmessage('Fichier image '+openpicturedialog1.Filename+ ' incorrect.');
       exit;
     end;
   end;
   initbitmap;
   angle := 0.0;
   afficheangle(angle);
   paintbox1.invalidate;
   openpicturedialog1.initialdir := '';
 end;
end;

procedure Tform1.initbitmap;
begin
  if Image1.picture.graphic <> nil then
   begin
     Bmp1.free;
     Bmp1 := Tbitmap.create;
     bmp1.pixelformat := pf24bit;
     bmp1.width  := Image1.picture.graphic.width;
     bmp1.height := Image1.picture.graphic.height;
     bmp1.canvas.draw(0,0,Image1.picture.graphic);
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  px, py : integer;
begin
  // centrage de l'image
  paintbox1.canvas.draw(
 (paintbox1.width-bmp1.width) div 2, (paintbox1.height-bmp1.height) div 2, bmp1);
  IF AAction = 2 then poignees;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;
//----------------- fin section traitement de la fiche --------------

// Rotation de Bmp1 de aangle en radians
// Rsultat dans Bmp1
procedure BmpRotation(Bmp1: Tbitmap; aangle: single; optim : boolean);
const
  kk = 3;
var
  bmp2 : tbitmap;
  dx, dy :   single;       // pour les calculs en rels
  cx1, cy1 : integer;
  cx2, cy2 : integer;
  x, y :  integer;         // pixel destination
  x2, y2   :  integer;     // pixel source rotation (bmp2)
  dyx, dyy, dxx, dxy  : single;
  modx, mody : integer;
  R, G, B : integer;   // stockage addition des couleurs de 4 points
  Remplissage : Tcolor;
  filler : Trgbtriple;
  sommet1  : tpoint;
  sommet2  : Tpoint;
  sommet3  : tpoint;
  sommet4  : tpoint;
  mx, my   : integer;
  debx, finx, deby, finy : integer;
  ksin, kcos : single;
  Tscan1 : array[0..2047] of pRGBArray;  // Bmp1
  Tscan2 : array[0..2047] of PRGBArray;  // Bmp2

  procedure npixels(ay, ax, mx, my : integer); // lissage matrice convolution 3x3
  var
    i, j : integer;
    am : integer;      // n de matrice
    nj , ni : integer;
    R0,G0,B0 : integer;
  begin
    am := my*kk+mx;
    R0 := 0; G0 := 0; B0 := 0;
    for j := ay-1 to ay+1 do
      for i := ax-1 to ax+1 do
      begin
        nj := j-ay+1;
        ni := i-ax+1;
        R0 := R0+Tscan2[j,i].Rgbtred  *MM[am, nj, ni];
        G0 := G0+Tscan2[j,i].Rgbtgreen*MM[am, nj, ni];
        B0 := B0+Tscan2[j,i].Rgbtblue *MM[am, nj, ni];
      end;
    R := R0 div 32;
    G := G0 div 32;
    B := B0 div 32;
  end;

begin
  if aangle = 0.0 then exit;
  cx1 := bmp1.width div 2;   // centre de l'image source
  cy1 := bmp1.height div 2;
  if cx1 < 1 then cx1 := 1;
  if cy1 < 1 then cy1 := 1;
  Bmp1.pixelformat := pf24bit;
  // on prend arbitrairement le gris comme couleur de remplissage
  Remplissage := clsilver;
  Filler.RgbtRed   := getRvalue(colortorgb(remplissage));
  Filler.RgbtGreen := getGvalue(colortorgb(remplissage));
  Filler.RgbtBlue  := getBvalue(colortorgb(remplissage));
  // calcul de l'augmentation de la taille du bitmap aprs rotation
  sommet1 := rotpt(cx1, cy1, 0, 0, aangle);
  sommet2 := rotpt(cx1, cy1, Bmp1.width,0, aangle);
  sommet3 := rotpt(cx1, cy1, bmp1.width, bmp1.height, aangle);
  sommet4 := rotpt(cx1, cy1, 0, bmp1.height, aangle);
  sommet1.x := abs(sommet1.x - cx1);
  sommet1.y := abs(sommet1.y - cy1);
  sommet2.x := abs(sommet2.x - cx1);
  sommet2.y := abs(sommet2.y - cy1);
  sommet3.x := abs(sommet3.x - cx1);
  sommet3.y := abs(sommet3.y - cy1);
  sommet4.x := abs(sommet4.x - cx1);
  sommet4.y := abs(sommet4.y - cy1);
  mx := maxi(sommet1.x, maxi(sommet2.x, maxi(sommet3.x, sommet4.x)));
  my := maxi(sommet1.y, maxi(sommet2.y, maxi(sommet3.y, sommet4.y)));
  mx := (Bmp1.width * mx) div cx1;
  my := (Bmp1.height* my) div cy1;
  bmp2 := tbitmap.create;    // on calcule la taille de bmp2 et de bmp1
  try
    bmp2.width   := maxi(mx, my);
    bmp2.height  := bmp2.width;
    bmp2.pixelformat := pf24bit;
    with bmp2.canvas do
    begin
      brush.color := remplissage;
      fillrect(cliprect);
      bmp2.canvas.draw(
      (bmp2.width-bmp1.width) div 2, (bmp2.height-bmp1.height) div 2, bmp1);
    end;
    bmp1.width  := mx;
    bmp1.height := my;
    // optimisation travail sur plusieurs scanlignes rutilises
    // prcalcul des pointeurs de scanlines
    For y := 0 to bmp1.height-1 do  Tscan1[y] := Bmp1.scanline[y];
    For y := 0 to bmp2.height-1 do  Tscan2[y] := bmp2.scanline[y];
    cx1 := (bmp1.width*kk) div 2;   // centre de rotation = centre de l'image
    cy1 := (bmp1.height*kk) div 2;
    cx2 := (Bmp2.width*kk) div 2;
    cy2 := (bmp2.height*kk) div 2;
    // les calculs se font en coordonnes x 3  cause du procd de lissage
    ksin := sin(aangle);
    kcos := cos(aangle);
    For y := 0 to Bmp1.height-1 do
    begin
      dy := (y*kk)-cy1;                  // distance y au centre
      dyx :=  dy*ksin;
      dyy :=  dy*kcos;
      for x :=0 to Bmp1.width-1 do
      begin
        dx := (x*kk)-cx1;                // distance x au centre
        dxx :=  dx * kcos;
        dxy :=  dx * ksin;
        x2 := cx2 + round(dxx-dyx);   // Rotation
        y2 := cy2 + round(dxy+dyy);
        modx := x2 mod kk;           // position metteur grille 3x3
        mody := y2 mod kk;           // pour matrice transposition
        x2 := x2 div kk;             // les coordonnes taient x 3 on divise
        y2 := y2 div kk;             // les coordonnes taient x 3 on divise
        IF (x2>=0) and (y2>=0) and (x2<bmp2.width) and (y2<bmp2.height) then
        begin
          R := Tscan2[y2,x2].Rgbtred;
          G := Tscan2[y2,x2].Rgbtgreen;
          B := Tscan2[y2,x2].Rgbtblue;
          // lissage sauf sur les bords
          if optim AND (x2 > 0) and (y2 > 0) and
             (x2 < bmp2.width-1) and (y2 < bmp2.height-1) then
             npixels(y2, x2, modx, mody);
          if R > 255 then R := 255 else if R < 0 then R := 0;
          if G > 255 then G := 255 else if G < 0 then G := 0;
          if B > 255 then B := 255 else if B < 0 then B := 0;
          Tscan1[y,x].Rgbtred   :=  R;
          Tscan1[y,x].Rgbtgreen :=  G;
          Tscan1[y,x].Rgbtblue  :=  B;
        end
        else Tscan1[y, x] := filler;  // pas de correspondance
      end;  // for x
    end;    // for y
  finally
    bmp2.free;
  end;
end;


// on redimensionne le bitmap Bmp1 en utilisant le bitmap de manoeuvre Bmp2
// le principe est le mme que pour le lissage de la rotation ci dessus.
// Approximation du pixel destination en fonction du calcul avec
// cordonnes multiplies par 3 ce qui donne 9 possibilits dans le pixel
// origine. Selon cette position(centre , prs du bord , coin) une
// matrice d'interpolation diffrente est utilise pour pondrer le pixel
// origine avec les 8 pixels voisins.
// si optim = false on utilise stretchdraw

procedure SmoothResize(Bmp1 : tbitmap; NewWidth, NewHeight:integer; optim: boolean);

var
  x, y : integer;
  x1, y1 : integer;
  tx, ty, modx, mody, m : integer;  // calcul en entiers * 3
  row2 : Prgbarray;
  oldwidth, oldheight : integer;
  R,G,B : integer;
  Bmp2 : Tbitmap;
  Tscan1 : array[0..2047] of pRGBArray;  // Bmp1

  procedure npixels(ay, ax, am : integer);
  var
    i, j : integer;
    nj , ni : integer;
    R0,G0,B0 : integer;
  begin
    R0 := 0; G0 := 0; B0 := 0;
    for j := ay-1 to ay+1 do
      for i := ax-1 to ax+1 do
      begin
        nj := j-ay+1;
        ni := i-ax+1;
        R0 := R0+Tscan1[j,i].Rgbtred  *MM[am, nj, ni];
        G0 := G0+Tscan1[j,i].Rgbtgreen*MM[am, nj, ni];
        B0 := B0+Tscan1[j,i].Rgbtblue *MM[am, nj, ni];
      end;
    R := R0 div 32;
    G := G0 div 32;
    B := B0 div 32;
  end;

begin
  bmp1.pixelformat := pf24bit;
  oldwidth  := Bmp1.width;
  oldheight := Bmp1.height;
  if newheight > 2048 then
  begin
    showmessage('Dimension invalide (hauteur > 2048 lignes)');
    exit;
  end;
  if (newwidth < 8) or (newheight < 8) then
  begin
    showmessage('Dimension invalide ( < 8)');
    exit;
  end;
  bmp2 := tbitmap.create;
  try
    bmp2.width   := NewWidth;
    bmp2.height  := NewHeight;
    bmp2.pixelformat := pf24bit;
    if optim = false then
      bmp2.canvas.stretchdraw(rect(0,0,Newwidth, newheight),  Bmp1)
    else
    begin
     //  Bmp1 source et Bmp2 destination
     For y := 0 to bmp1.height-1 do  Tscan1[y] := Bmp1.scanline[y];
     // traitement
     For y := 0 to bmp2.height-1 do
     begin
      row2 := bmp2.scanline[y];    // scanline destination
      ty := (y*3*oldheight) div newheight;  // calcul position y origine*3
      mody := ty mod 3;
      y1   := ty div 3;
      For x := 0 to Bmp2.width-1 do
      begin
        tx := (x*3*oldwidth) div newwidth;  // calcul position y origine*3
        modx := tx mod 3;
        x1   := tx div 3;
        IF (x1>0) and (y1>0) and (x1< bmp1.width-1) and (y1<bmp1.height-1) then
        begin
          M := mody*3+modx;
          npixels(y1, x1, M);
        end
        else
        begin
          y1 := (y*oldheight) div newheight;
          x1 := (x*oldwidth)  div newwidth;
          if y1 < 0 then y1 := 0;
          if y1 > bmp1.height - 1 then y1 := bmp1.height-1;
          if x1 < 0 then x1 := 0;
          if x1 > bmp1.width - 1 then x1 := bmp1.width-1;
          R := Tscan1[y1,x1].Rgbtred;
          G := Tscan1[y1,x1].Rgbtgreen;
          B := Tscan1[y1,x1].Rgbtblue;
        end;
        if R > 255 then R := 255 else if R < 0 then R := 0;
        if G > 255 then G := 255 else if G < 0 then G := 0;
        if B > 255 then B := 255 else if B < 0 then B := 0;
        row2[x].Rgbtred   := R;
        row2[x].Rgbtgreen := G;
        row2[x].Rgbtblue  := B;
      end;   // for x
     end;   // for y
    end;  // if optim
    bmp1.assign(bmp2);  // Bmp1 devient Bmp2
  finally
    bmp2.free;
  end;
end;

procedure cutbitmap(abitmap: tbitmap; arect: trect);
var
  bmp2 : tbitmap;
begin
  if arect.left < 0 then arect.left := 0;
  if arect.right > abitmap.width then arect.right := abitmap.width;
  if arect.top < 0 then arect.top := 0;
  if arect.bottom > abitmap.height then arect.bottom := abitmap.height;
  bmp2 := tbitmap.create;
  try
    bmp2.width   := arect.right-arect.left;
    bmp2.height  := arect.bottom-arect.top;
    bmp2.pixelformat := pf24bit;
    bmp2.canvas.copyrect(rect(0,0,bmp2.width, bmp2.height), Bmp1.canvas, arect);
    abitmap.assign(bmp2);
  finally
    bmp2.free;
  end;
end;

procedure TForm1.Button3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  x2, y2 : integer;
  px, py : integer;
begin
  x2 := bmp1.width*2;
  y2 := bmp1.height*2;
  px := (paintbox1.width-x2) div 2;  // centrage
  py := (paintbox1.height-y2) div 2;  // centrage
  paintbox1.canvas.stretchdraw(bounds(px, py, x2,y2), bmp1);
end;

procedure TForm1.Button3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  paintbox1.invalidate;
end;

procedure Tform1.afficheangle(aaa : single);
begin
  edit1.text := formatfloat('0.0', (aaa*180)/ pi)+'';
end;

procedure Tform1.afficheDimensions;
begin
  label5.caption := inttostr(RR.right - RR.left);
  label6.caption := inttostr(RR.bottom-RR.top);
end;

procedure TForm1.axesrotation(ax, ay : integer; zangle : single);
var
  ww, hh : integer;
  pp : array[0..4] of Tpoint;
begin
  // dessin des axes de rotation rotation de centre cx, cy du point (wx, wy)
  ww := paintbox1.width div 4;
  hh := paintbox1.height div 4;
  with paintbox1.canvas do
  begin
    pen.width := 1;
    pen.mode := pmnotxor;
    pen.color := clred;
    moveto(centrex*2 -ax, centrey*2 -ay);
    lineto(ax, ay);
    pp[0] := rotpt(centrex, centrey, centrex-ww, centrey-hh, zangle);
    pp[1] := rotpt(centrex, centrey, centrex+ww, centrey-hh, zangle);
    pp[2] := rotpt(centrex, centrey, centrex+ww, centrey+hh, zangle);
    pp[3] := rotpt(centrex, centrey, centrex-ww, centrey+hh, zangle);
    pp[4] := pp[0];
    pen.color := clgray;
    polyline(pp);
    moveto((pp[0].x+pp[1].x) div 2, (pp[0].y+pp[1].y) div 2);
    lineto((pp[2].x+pp[3].x) div 2, (pp[2].y+pp[3].y) div 2);
    moveto((pp[0].x+pp[3].x) div 2, (pp[0].y+pp[3].y) div 2);
    lineto((pp[1].x+pp[2].x) div 2, (pp[1].y+pp[2].y) div 2);
  end;
end;

  // Dessine les poignes de redimensionnement en mode NOTXOR
procedure Tform1.poignees;

  Procedure carre(ax, ay: integer);  // dessine un petit carr
   var
     i : integer;
   begin
     for i := 0 to 4 do
     begin
       paintbox1.canvas.moveto(ax-2, ay-2+i);
       paintbox1.canvas.lineto(ax+2, ay-2+i);
     end;
   end;

begin
  with paintbox1.canvas do
  begin
    pen.width := 1;
    pen.color := clblack;
    pen.mode  := pmnotxor;
    moveto(RR.left, RR.top);
    lineto(RR.right, RR.top);
    lineto(RR.right, RR.bottom);
    lineto(RR.left, RR.bottom);
    lineto(RR.left, RR.top);
    carre(RR.left, RR.top);
    carre((RR.left+rr.right) div 2, rr.top);
    carre(RR.right, RR.top);
    carre(RR.right, (RR.top+rr.bottom) div 2);
    carre(RR.right, RR.bottom+1);
    carre((RR.left+rr.right) div 2, rr.bottom);
    carre(RR.left, RR.bottom);
    carre(RR.left, (RR.top+rr.bottom) div 2);
    pen.mode := pmcopy;
  end;
end;

// renvoie zro si pas clic poigne sinon le rang 1..8 d'un des 8 points cliqu
// renvoie 9 si clic  l'intrieur du rectangle pour dplacement
Function Tform1.clicpoignee(ax, ay : integer): integer;
const
  p = 4;   // prcision de la zone zone clique = 4*2 =  carr de 8 pixels
var
  pt : tpoint;
begin
  result := 0;
  pt.x := ax;
  pt.y := ay;
  if ptinrect(rect(RR.left-p, RR.top-p, RR.left+p, RR.top+p), pt) then result := 1
  else
  if ptinrect(rect((RR.left+RR.right) div 2-p, RR.top-p,
                  (RR.left+RR.right) div 2+p, RR.top+p), pt) then result := 2
  else
  if ptinrect(rect(RR.right-p, RR.top-p,
                   RR.right+p, RR.top+p), pt) then result := 3
  else
  if ptinrect(rect(RR.Right-p, (RR.top+RR.bottom) div 2- p,
                   RR.Right+p, (RR.top+RR.bottom) div 2+ p), pt) then result := 4
  else
  if ptinrect(rect(RR.Right-p, RR.bottom-p,
                   RR.Right+p, RR.bottom+p), pt) then result := 5
  else
  if ptinrect(rect((RR.left+RR.right) div 2 -p, RR.bottom-p,
                   (RR.left+RR.right) div 2 +p, RR.bottom+p), pt) then result := 6
  else
  if ptinrect(rect(RR.left-p, RR.bottom-p,
                   RR.left+p, RR.bottom+p), pt) then result := 7
  else
  if ptinrect(rect( RR.left-p, (RR.top+RR.bottom) div 2 -p,
                    RR.left+p, (RR.top+RR.bottom) div 2 +p), pt) then result := 8
   else
  if ptinrect(RR, pt) then result := 9;
end;

Procedure Tform1.Movepoignee(dx, dy, numero : integer);
begin
  case numero of
    1 : begin RR.left := RR.left+dx; RR.top := RR.top+dy; end;
    2 : RR.top := RR.top+dy;
    3 : begin RR.right := RR.right+dx; RR.top := RR.top+dy; end;
    4 : RR.right := RR.right+dx;
    5 : begin RR.right := RR.right+dx; RR.bottom := RR.bottom+dy; end;
    6 : RR.bottom := RR.bottom+dy;
    7 : begin RR.left := RR.left+dx; RR.bottom:= RR.bottom+dy; end;
    8 : RR.left := RR.left+dx;
    9 : offsetrect(RR, dx, dy);  //  cf fonctions rectangle de l' API Windows
  end; // case
  // le rectangle doit rester avec right >= left+8 et bottom >= top+8
  IF RR.right  < RR.left+8 then RR.right  := RR.left + 8;
  IF RR.bottom < RR.top+8  then RR.bottom := RR.top +8;
  poignees;  // le dessin des poignes utilise le rectangle RR
end;

Procedure Tform1.Homothetie(x, y : integer);
var
  d1, d2, w, h : integer;
begin
  if numpoigne mod 2 = 1 then     // cas des angles
  begin
    d1 := distance(0,0,bmp1.width, bmp1.height) div 2;
    d2 := distance(centrex, centrey, x, y);
  end
  else
  if (numpoigne = 2) or (numpoigne = 6) then
  begin
    d1 := distance(0,0,0, bmp1.height) div 2;
    d2 := distance(centrex, centrey, centrex, y);
  end
  else
  begin
    d1 := distance(0,0,bmp1.width, 0) div 2;
    d2 := distance(centrex, centrey, x, centrey);
  end;
  if d1 < 8 then d1 := 8;
  if d2 < 8 then d2 := 8;
  repeat                            // si bitmap rduit  pixels mini
    w := (bmp1.width*d2) div d1;
    h := (bmp1.height*d2) div d1;
    inc(d2);
  until (w > 16) and (h > 16);
  RR := bounds((paintbox1.width-w) div 2, (paintbox1.height-h) div 2, w, h);
  poignees;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  startx := x;   // mmorise pour effacement axes en notxor
  starty := y;
  case AAction of
  1 : begin
        drawing := true;
        angle := inclin(centrex, centrey, x,y);
        axesrotation(x,y, angle);
        afficheangle(angle);
      end;
  2 : begin
        numpoigne :=  clicpoignee(x, y);
        if (numpoigne > 0) and (numpoigne < 9) then drawing := true;
      end;
  3 : begin
        drawing := true;
        selrect := rect(x, y, x+2, y+2);
        drawfocusrect(paintbox1.canvas.handle, selrect);
      end;
  end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  ddx, ddy : integer;
begin
  if not drawing then // changement de curseur si survol des poignes
  begin
    if AAction = 2 then
    begin
      numpoigne := clicpoignee(x, y);
      case numpoigne of
      1, 5 : screen.cursor := crsizeNWSE;
      2, 6 : screen.cursor := crsizeNS;
      3, 7 : screen.cursor := crsizeNESW;
      4, 8 : screen.cursor := crsizeWE;
      // 9 :  screen.cursor := crsize;  // pas de dplacement ici
      else
      screen.cursor := crdefault;
      end;
    end;
    exit;
  end;
  case AAction of
  1 : axesrotation(startx, starty, angle);
  2 : poignees;
  3 : drawfocusrect(paintbox1.canvas.handle, selrect);
  end;
  ddx := x-startx;
  ddy := y-starty;
  startx := x;
  starty := y;
  case AAction of
  1 : begin
        angle := inclin(centrex, centrey, x,y); // origine angles trigononrique
        axesrotation(x, y, angle);
        afficheangle(angle);
      end;
  2 : begin
        if checkbox1.checked then homothetie(x,y)
        else movepoignee(ddx, ddy, numpoigne);
        Affichedimensions;
      end;
  3 : begin
        selrect := rect(selrect.left, selrect.top, x, y);
        drawfocusrect(paintbox1.canvas.handle, selrect);
      end;
  end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  x1, y1 : integer;
begin
  if not drawing then exit;
  Case AAction of
  1 : begin
        axesrotation(startx, starty,angle);
        drawing := false;
        Bmprotation(bmp1, angle, checkoptim.checked);
        paintbox1.invalidate;
      end;
  2 : begin
        drawing := false;
        smoothresize(bmp1, RR.right-RR.left, RR.bottom-RR.top, checkoptim.checked);
        image1.picture.graphic.assign(bmp1);
        RR := bounds((paintbox1.width-bmp1.width) div 2,
                (paintbox1.height-bmp1.height) div 2, bmp1.width, bmp1.height);
        paintbox1.invalidate;
      end;
  3 : begin
        drawfocusrect(paintbox1.canvas.handle, selrect);
        drawing := false;
        x1 := (paintbox1.width  - bmp1.width)  div 2;
        y1 := (paintbox1.height - bmp1.height) div 2;
        offsetrect(selrect, -x1, -y1);
        cutbitmap(bmp1, selrect);
        paintbox1.invalidate;
      end;
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  IF sender = speedbutton1 then   // rotation
  begin
    groupbox1.visible := true;
    groupbox2.visible := false;
    if AAction = 2 then poignees;
    AAction := 1;
  end
  else
  if sender = speedbutton2 then
  begin                     // resize
    groupbox1.visible := false;
    groupbox2.visible := true;
    AAction := 2;
    RR := bounds((paintbox1.width-bmp1.width) div 2,
        (paintbox1.height-bmp1.height) div 2, bmp1.width, bmp1.height);
    poignees;
    affichedimensions;
  end
  else
  if sender = speedbutton3 then
  begin
    groupbox1.visible := true;
    groupbox2.visible := true;
    if AAction = 2 then poignees;
    AAction := 3;
  end;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  case combobox1.itemindex of
  0 : angle := - pi/2;
  1 : angle := -pi/4;
  2 : angle := 0;
  3 : angle := pi/4;
  4 : angle := Pi/2;
  5 : angle := pi;
  end;
  afficheangle(angle);
  initbitmap;
  Bmprotation(bmp1, angle, checkoptim.checked);
  paintbox1.invalidate;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Image1.Picture.LoadFromFile(openpicturedialog1.Filename);
  initbitmap;
  RR := bounds((paintbox1.width-bmp1.width) div 2,
        (paintbox1.height-bmp1.height) div 2, bmp1.width, bmp1.height);
  paintbox1.invalidate;
  affichedimensions;
end;

end.
